include "CSS34P17.inc"
include "macro.inc"
;============================================
;css34p17ϵͳʼ
;============================================
Pro_Sys_Init:
	call	mck_wdt_init					;ʱӡŹ״̬Ĵʼ
	call	clrram0							;ּͨĴ
	call	io_init							;IOڳʼ
	call	time_init						;ʱʼ
	call	ad_init							;ADʼ
	call	CMP_Init						;Ƚʼ
	call	UART_Init						;ڳʼ
	call	TypeC_Init						;Type-C IOڳʼ
	DW		0FFFFH
	DW		0FFFFH
	nop
	call	int_init						;жϳʼ		
	return

;============================================
;ʱӡŹ״̬Ĵ ʼ
;============================================
mck_wdt_init:
	clrf	STATUS							;״̬Ĵ
											;״̬Ĵϵ縴λֵΪxxu00000
											;Bit 7   	LVD363.6V LVDѹ־ֻеѡLVD_SELΪ2'b012'b10Ч
											;	1ϵͳѹ3.6V˵͵ѹѴڼ״̬
											;	0ϵͳѹ3.6V͵ѹûй
											
											;Bit 6   	LVD242.4V LVDѹ־ֻеѡLVD_SELΪ2'b01Ч
											;	1ϵͳѹ2.4V˵͵ѹѴڼ״̬
											;	0ϵͳѹ2.4V͵ѹûй
											
											;Bit 4    	PD־λͨԴλд0㣬sleepôλ
											;	1ִSLEEPָ
											;	0ϵ縴λӲλCLRWDTָ֮
											
											;Bit 3    	TOŹʱ־ͨԴλд0㣬Źʱôλ
											;	1Źʱ
											;	0ϵ縴λӲλCLRWDTָSLEEPָ
											
											;Bit 2     	DCֽڽλ־/λ־(ڽλʱ෴)
											;	1ĵ4λֽλ
											;	0ĵ4λֽλ
											
											;Bit 1 		C   λ־/λ־(ڽλʱ෴)
											;	1λMSBֽλ
											;	0λMSBֽλ
											
											;Bit 0	  	Z־
											;	1߼ǽΪ0
											;	0߼ǽΪ0
											
	movlf	10000000b,MCK		    		; ڲ񡢴ڲWDT
											; mck(ϵ縴λֵΪ1010uuu0)
										 	; bit7(CST)   ⲿ   
											;	1ⲿر   0ⲿ
											
											; bit6(CST_IN): ڲ   
											;	1ڲر   0ڲ
											
											; bit5(CST_WDT):ڲWDT
											;	1ڲWDTر0ڲWDT
											
											; bit4(EO_SLP): ⲿپλ 
											;	1ѡⲿپ32768Hzsleepģʽ²رⲿ
											;	0sleepģʽ¹رⲿ
											
											; bit0(CLKSEL):ʱԴѡλ(CPUʱ)
											;	1:ⲿϵͳʱ
											;	0:ڲϵͳʱ
	
	movlf	11111111b,WDTIN					; wdtin(ϵ縴λֵΪ11111111)
	
	movlf	10000001b,WDTCON				; ʹܿŹ1.024Sλ			
							 				; wdtcon:(ϵ縴λΪ0uuuu000)	
							 				; bit7(wdten):Źʱλ; 
							 				
							 				; bit[2-0](wdts): wdtinΪffhʱ
											;	000    		ʱΪ 2048ms
											;	001    		ʱΪ 1024ms
											;	010    		ʱΪ 512ms
											;	011    		ʱΪ 256ms
											;	100    		ʱΪ 128ms
											;	101    		ʱΪ 64ms
											;	110    		ʱΪ 32ms
											;	111    		ʱΪ 16ms
	return
;============================================
; ּͨĴ
;============================================
clrram0:									;clr ram 80h-FFh      ּͨĴ
	movlw	80h
	movwf	FSR0	        				;FSR0 еֵΪַȥݴ洢õ			 	     	
clrram0_loop:	
	clrf	IND0					
	incfsz	FSR0,1  
	goto	clrram0_loop
	
	bsf		BSR,7							;÷100H--167HRAM
	movlw	00h
	movwf	FSR0
clrram0_loop2:
	clrf	IND0
	incf	FSR0,1
	movlw	68h
	subwf	FSR0,0
	btfss	STATUS,C
	goto	clrram0_loop2
	bcf		BSR,7	
	
	return			
;============================================
;IO ʼ
;˿ڶ˵
;ptx:	0:˿ʱΪ͵ƽ1˿ʱΪߵƽ
;ptxen:	0:ڣ			  1ڣ
;ptxpu:	0:ڲֹ	  1ڲʹܣ
;============================================
io_init:

	
	clrf	PT1								;GPIO 1ݱ־λ	pt1[7:1]ϵ縴λֵxxxxxxxu
	
	movlw	00110110B
	movwf	PT1EN
	
	movlw	00000000b	
	movwf	PT1PU  	    
	  
  	movlw	00000001b  						;ⲿж1ⲿж0               
	movwf	PT1CON   						;pt1con[7:0]ϵ縴λֵΪ00000000						
											;bit 6 PT1W[3]:PT1.5ⲿж1ʹ
											;0 = ֹPT1.5ⲿж1
											;1 = ʹPT1.5ⲿж1
											
											;bit 5 PT1W[2]:PT1.4ⲿж1ʹ
											;0 = ֹPT1.4ⲿж1
											;1 = ʹPT1.4ⲿж1
											
											;bit 4 PT1W[1]:PT1.3ⲿж1ʹ
											;0 = ֹPT1.3ⲿж1
											;1 = ʹPT1.3ⲿж1
											
											;bit 3 PT1W[0]:PT1.1ⲿж1ʹ
											;0 = ֹPT1.1ⲿж1
											;1 = ʹPT1.1ⲿж1
											
											;bit 2 E1Mⲿж1ģʽ
											;1 = ⲿж1Ϊ½ش
											;0 = ⲿж1״̬ıʱ
											
											;bit 1:0 E0M[1:0]ⲿж0ģʽ
											;11 = ⲿж0״̬ıʱ
											;10 = ⲿж0״̬ıʱ
											;01 = ⲿж0Ϊش
											;00 = ⲿж0Ϊ½ش

	clrf	PT3								;GPIO 3ݱ־λ	pt3[7:0]ϵ縴λֵxxxxxxxx

	movlw	00000101b
	movwf	PT3EN							;GPIO 3/Ʊ־                
	                                        ;pt3en[7:0]ϵ縴λֵΪ00000000       
	                                        ;		0 = Ϊڣ1 = Ϊ

	clrf	PT3PU  	  						;GPIO 3ʹܱ־	                
	                                        ;PT3PU[7:0]ϵ縴λֵΪ00000000         
	                                        ;		0 = Ͽ裬1 = ʹ  
	
	clrf	PT3CON  						;GPIO 3ģ/ֶ˿ʹܱ־              
	                                        ;pt3con[7:0]ϵ縴λֵΪ00000000        
	                                        ;		0 = Ϊֿڣ1 = Ϊģ  
	    								
	clrf	PT5								;GPIO5ݱ־λ	PT5[2:0]ϵ縴λֵΪuuuuuxxx
	
	movlw	00000001b
	movwf	PT5EN
	
	clrf	PT5PU  	  
											
	clrf	PT5CON 							;pt5.0pt5.1pt5.2ֹ©		  
	                                        ;pt5con[2:0]ϵ縴λֵΪuuuuuxxx      
	                                        ;Bit 2		PT51ODpt5.1 Ʊ־λ	      
	                                        ;			0 = ֹ©1 = ʹܿ©
	                                        
	                                        ;Bit 1		PT50ODpt5.0 Ʊ־λ	      
	                                        ;			0 = ֹ©1 = ʹܿ©   
	                                        
	                                        ;Bit 0		PT5CON0pt5.0 Ʊ־λ         
	                                        ;			0 = Ϊֿڣ1 = Ϊģ    
	                                        
	
	clrf	EX_CTL							;ⲿж1ⲿж0               
		                                    ;ex_ctl[7:0]ϵ縴λֵΪ00u00000
											;Bit 7 		EX0W[1]:PT3.3ⲿж0ʹ
											;			0 = ֹPT3.3ⲿж0          
											;			1 = ʹPT3.3ⲿж0    
											      
											;Bit 6 		EX0W[0]:PT3.2ⲿж0ʹ
											;			0 = ֹPT3.2ⲿж0          
											;			1 = ʹPT3.2ⲿж0   
											
											;Bit 4 		PT1W2[4]:PT3.6ⲿж1ʹ
											;			0 = ֹPT3.6ⲿж1           
											;			1 = ʹPT3.6ⲿж1      
											     
											;Bit 3 		PT1W2[3]:PT3.5ⲿж1ʹ
											;			0 = ֹPT3.5ⲿж1           
											;			1 = ʹPT3.5ⲿж1 
											          
											;Bit 2 		PT1W2[2]:PT1.7ⲿж1ʹ
											;			0 = ֹPT1.7ⲿж1           
											;			1 = ʹPT1.7ⲿж1   
											        
											;Bit 1 		PT1W2[1]:PT1.6ⲿж1ʹ
											;			0 = ֹPT1.6ⲿж1           
											;			1 = ʹPT1.6ⲿж1    
											       
											;Bit 0 		PT1W2[0]:PT1.2ⲿж1ʹ       
											;			0 = ֹPT1.2ⲿж1           
											;			1 = ʹPT1.2ⲿж1           
	
	clrf 	EX2_CTL							;ⲿж2ʹģʽ
	                                        ;ex2_ctl[7:0]ϵ縴λֵΪ00uuuu00
	                                        ;Bit 7 		EX2W[1]:PT5.0ⲿж2ʹ    
	                                        ;			0 = ֹPT5.0ⲿж2              
	                                        ;			1 = ʹPT5.0ⲿж2  
	                                                    
	                                        ;Bit 6 		EX2W[0]:PT3.7ⲿж2ʹ    
	                                        ;			0 = ֹPT3.7ⲿж2              
	                                        ;			1 = ʹPT3.7ⲿж2 
	                                                     
	                                        ;Bit 1-0 	E2M[1:0]ⲿж 2ģʽ
	                                        ;			11 = ⲿж2״̬ıʱ      
	                                        ;			10 = ⲿж2״̬ıʱ      
	                                        ;			01 = ⲿж2Ϊش          
	                                        ;			00 = ⲿж2Ϊ½ش          
	
	movlw	11010000b  	
	movwf	SYSCFG1    						;IO
											;bit 7   	PDP14      	PT1.4(Ĭϴ)                	                                        
	                                        ;			1 PT1.4ڽ1K  
	                                        ;			0PT1.4ڲ    
	                                         
	                                        ;bit 6      PDP13       PT1.3(Ĭϴ)            	                                        
	                                        ;			1 PT1.3ڽ500K
	                                        ;			0PT1.3ڲ    
	                                         
	                                        ;bit 5      PDP12       PT1.2(Ĭϴ)           
	                                        ;			1 PT1.2ڽ10K 
	                                        ;			0PT1.2ڲ 
	                                            
	                                        ;bit 4      PUP11       PT1.1(Ĭϴ)            
	                                        ;			1 PT1.1ڽ40K 
	                                        ;			0PT1.1ڲ    
	                                         
	                                        ;bit 3      PDP36       PT3.6           	                                                  
	                                        ;			1 PT3.6ڽ30K 
	                                        ;			0PT3.6ڲ    
	                                         
	                                        ;bit 2      PDP35       PT3.5        
	                                        ;			1 PT3.5ڽ30K 
	                                        ;			0PT3.5ڲ
	                                             
											;bit[1:0]	
	
	return   		                        	
;============================================
; ʱʼ
;============================================
time_init:
	movlw	11110000b 						
	movwf	TM0CON							;öʱ0оƬþΪ14.4MHz
											;	˴t0rate=cpu/128=3.6M/128=28.125K	=35.56us
										    ;tm0conϵ縴λֵΪ0000u100                                           
										    ;Bit 7  	t0en  ʱ0ʹλ                                               	
										    ;			1ʹܶʱ0                                                    
										    ;	  		0ֹʱ0                                                    
										                                                                                  
										    ;Bit[6:4] 	t0rate[2:0]		ʱ0ʱѡ                                   
										    ;			t0rate [2:0]     tm0clk                                           
				             			    ;			000		         ckt0                                             
										    ;	 		001				 ckt0 /2                                          
										    ;			010				 ckt0 /4                                          
										    ;			011				 ckt0 /8                                          
										    ;			100				 ckt0 /16                                         
										    ;			101				 ckt0 /32                                         
										    ;			110				 ckt0 /64                                         
										    ;			111				 ckt0 /128                                        
									 	                                                                                  
									 	    ;Bit 2 		t0rstb	ʱ0λ                                               
										    ;			1ֹʱ0λ                                                
										    ;			0ʹܶʱ0λλΪ0ʱʱ0λT0RSTBԶ1 
										                                                                                  
										    ;Bit[1:0]	t0sel[1:0]	ʱԴѡ                                            
										    ;			t0sel[1:0]	ʱ0ʱԴ                                         
										    ;			00          cpuclk                                                
										    ;			01			mck                                                   
										    ; 			01			MCK
										    ; 			10			ⲿ32768Hzʱӣⲿ32768HzҾʱЧ
										    ; 			11			ڲ32K WDTʱӣڲWDTʱЧ
	
	movlw	112								
	movwf	TM0IN							;tm0ʱΪ 35.56us*(124+1)=4.02ms	       
	                                        ;ʱ0ʱ㷽             
	                                        ;	ʱ0ʱ=(tm0in+1)/tm0clk   
	
	clrf	TM0CNT   
	
;--------------------------------------------
;ʱ/2ʼ 
	movlw	00000000b						
	movwf	TM2CON							;öʱ2                                                                        
											;tm2conϵ縴λֵΪ00000100                                                 
											;Bit 7 		t2en 	ʱ/2ʹλ                                              
											;       	1ʹܶʱ2                                                          
											;       	0ֹʱ2                                                          
											                                                                                    
											;Bit[6:4] 	t2rate[2:0] 	ʱ/2ʱѡ                                    
											;			t2rate [2:0]	tm2clk	(CKT2ʱԴѡTMCON2Ĵt2sel[1:0]λ)    
											;			000				ckt2                                                    
											;			001				ckt2 /2                                                 
											;			010				ckt2 /4                                                 
											;			011				ckt2 /8                                                 
											;			100				ckt2 /16                                                
											;			101				ckt2 /32                                                
											;			110				ckt2 /64                                                
											;			111				ckt2 /128                                               
                                                                                                                                
											;Bit 3 		t2cks	ʱ/2ʱԴѡλ                                        
											;			1pt3.0Ϊʱ                                                        
											;			0cpuclkmckķƵʱ                                                
											                                                                                    
											;Bit 2 		t2rstb 	ʱ/2λ                                                
											;			1ֹʱ/2λ                                                 
											;			0ʹܶʱ/2λλΪ0ʱʱ2λt2rstbԶ1  
											                                                                                    
											;Bit 1:0  	t2out pwm2out 	pt1.4ƣpt1.4ΪʱЧ              
											;			0	 	0	 	IO                                                  
											;		 	0		1		PWM2                                                
											;			1		0		                                              
											;			1		1		PWM2                                                
	
	clrf 	TM2IN 				                                                                
	clrf 	TM2INH 							;嶨ʱ/2ֵ                                           
											;ʱ2ʱ㷽                                      
	                            			; 	ʱ2ʱ=tm2in[11:0]+1/tm2clk tm2inΪ0     
	                            			                                                                
	clrf 	TM2R   							                                                                
	clrf 	TM2RH  							;嶨ʱ/2PWMߵƽռձȿƼĴ                      
	                            			                                                                
	clrf 	TM2CNT              			                                                                
	clrf 	TM2CNTH							;嶨ʱ/2Ĵ										

;--------------------------------------------
;ʱ/4ʼ  
	movlw	10000000b						
	movwf	TM4CON							;öʱ4                                                                          
											;tm4conϵ縴λֵΪ00000100                                                   
											;Bit 7 		t4en 	ʱ/4ʹλ                                                
											;       	1ʹܶʱ4                                                            
											;       	0ֹʱ4                                                            
											                                                                                      
											;Bit[6:4] 	t4rate[2:0] 	ʱ/4ʱѡ                                      
											;			t4rate [2:0]	tm4clk	(CKT4ʱԴѡTMCON2Ĵt4sel[1:0]λ)      
											;			000				ckt4                                                      
											;			001				ckt4 /2                                                   
											;			010				ckt4 /4                                                   
											;			011				ckt4 /8                                                   
											;			100				ckt4 /16                                                  
											;			101				ckt4 /32                                                  
											;			110				ckt4 /64                                                  
											;			111				ckt4 /128                                                 
                                                                                                                                  
											;Bit 3 		t4cks	ʱ/4ʱԴѡλ                                          
											;			1pt1.4Ϊʱ                                                          
											;			0cpuclkmckķƵʱ                                                  
											                                                                                      
											;Bit 2 		t4rstb 	ʱ/4λ                                                  
											;			1ֹʱ/4λ                                                   
											;			0ʹܶʱ/4λλΪ0ʱʱ4λt4rstbԶ1    
											                                                                                      
											;Bit 1:0  	t4out pwm4out 	pt1.6ƣpt1.6ΪʱЧ                
											;			0	 	0	 	IO                                                    
											;		 	0		1		PWM4                                                  
											;			1		0		                                                
											;			1		1		PWM4                                                  
	
	movlw	2eh								
	movwf 	TM4IN  				                                                             
    clrf 	TM4INH 							;tm4Ϊ tm4clk/(tm4in[11:0]+1)= 14.4M/(2eh+1)= 306.38k                                       
    										;ʱ4ʱ㷽                                   
                                			; 	ʱ4ʱ=tm4in[11:0]+1/tm4clk tm4inΪ0  
                                			                                                             
    clrf 	TM4R   							                                                             
    clrf 	TM4RH  							;嶨ʱ/4PWMߵƽռձȿƼĴ                   
                                			                                                             
    clrf 	TM4CNT              			                                                             
    clrf 	TM4CNTH							;嶨ʱ/4Ĵ                                    
	
	
	
	
;--------------------------------------------
;ʱ/3ʼ 
	
	movlw	00000000b						
	movwf	TM3CON							;öʱ3                                                                                   
											;tm3conϵ縴λֵΪ00000100                                                            
											;Bit 7 		t3en 	ʱ/3ʹλ                                                         
											;       	1ʹܶʱ3                                                                     
											;       	0ֹʱ3                                                                     
											                                                                                               
											;Bit[6:4] 	t3rate[2:0] 	ʱ/3ʱѡ                                               
											;			t3rate [2:0]	tm3clk	(CKT3ʱԴѡTMCON2Ĵt3sel[1:0]λ)               
											;			000				ckt3                                                               
											;			001				ckt3 /2                                                            
											;			010				ckt3 /4                                                            
											;			011				ckt3 /8                                                            
											;			100				ckt3 /16                                                           
											;			101				ckt3 /32                                                           
											;			110				ckt3 /64                                                           
											;			111				ckt3 /128                                                          
                                                                                                                                           
											;Bit 3 		t3cks	ʱ/3ʱԴѡλ                                                   
											;			1pt3.1Ϊʱ                                                                   
											;			0cpuclkmckķƵʱ                                                           
											                                                                                               
											;Bit 2 		t3rstb 	ʱ/3λ                                                           
											;			1ֹʱ/3λ                                                            
											;			0ʹܶʱ/3λλΪ0ʱʱ3λt2rstbԶ1             
											                                                                                               
											;Bit 1:0  	t3out pwm3out 	pt1.5ƣpt135ΪʱЧͬʱδʹܻPWM  
											;			0	 	0	 	IO                                                             
											;		 	0		1		PWM3                                                           
											;			1		0		                                                         
											;			1		1		PWM3                                                           
	
	clrf 	TM3IN  				                                                                
    clrf 	TM3INH 							;嶨ʱ/3ֵ                                           
    										;ʱ3ʱ㷽                                      
                                			; 	ʱ3ʱ=tm3in[11:0]+1/tm3clk tm3inΪ0     
                                			                                                                
    clrf 	TM3R   							                                                                
    clrf 	TM3RH  							;嶨ʱ/3PWMߵƽռձȿƼĴ                      
                                			                                                                
    clrf 	TM3CNT              			                                                                
    clrf 	TM3CNTH							;嶨ʱ/3Ĵ                                       
	

	clrf	TM3CON2							;ʱ                                             
											;tm3con2ϵ縴λֵΪ00000000                      
											;Bit[7:6]	dt3ck[1:0]	ʱ3ʱʱѡ           
											;			dt3ck[1:0]	dt3_clk                           
											;			00       	mck                               
											;			01       	mck/2                             
											;			10       	mck/4                             
											;			11       	mck/8                             
											                                                          
											;Bit[5:3]	dt3cnt[2:0]	PWM3ʱѡ                     
											;                        ʱ=dt3cnt[2:0]*(1/dt3_clk) 
											                                                          
											;Bit 2		dt3_en		3ʹλ                 
											;           0ʹ3                          
											;           1ʹ3                            
											                                                          
											;Bit 1 		p3h_oen		PWM3Hʹ                 
											;           0PWM3H                                
											;           1PWM3HPT1.2                           
											                                                          
											;Bit 0		p3l_oen		PWM3Lʹ                 
	                                        ;           0PWM3L                                
	                                        ;           1PWM3LPT1.1                           
	                                                                           	                                                                          	                                                                                       
	movlw	00100001b						;ûpwm3hpwm3l,pwm (ϵĬֵ00uuu000)  
	movwf	TMCON							;bit 7		p3hinv	PWM3Hȡλ                     
											; 			0PWM3Hȡ                                  
											; 			1PWM3Hȡ                                
											                                                            
											;bit 6		p3linv	PWM3Lȡλ                     
											;			0PWM3Lȡ                                  
											;			1PWM3Lȡ 
	
											;bit[5:3]	dt3cnt2[2:0]  PWM3½ʱѡ
											;					ʱ=DT3CNT2[2:0]*DT3_CLK                                                            
											
											;bit 2		pwm4po	PWM4ѡ                          
											;			0PT1.6ΪPWM4                          
											;			1PT3.6ΪPWM4                          
											                                                            
											;bit 1		pwm3po	PWM3ѡ                          
											;			0PT1.5ΪPWM3                          
											;			1PT3.5ΪPWM3                          
											                                                            
											;bit 0		pwm2po	PWM2ѡ                          
											;			0PT1.4ΪPWM2                          
											;			1PT5.0ΪPWM2                          

											
	movlw	00010100b						
	movwf	TMCON2							;ʱʱѡ;(ϵĬֵuu000000)                                        
											;bit 6		PWM3POL		PWM3ʼѡ
											;			0ʼΪ
											;			1ʼΪ
		
											;bit [5:4]	t4sel[1:0]	ʱ4ʱԴѡ                                       
											;			t4sel[1:0]	ʱ4ʱԴ                                           
											;			00			CPUCLK                                                  
											;			01			MCK                                                     
											;			1x			ⲿʱECK(ⲿⲿҾʱЧ) 
                                                                                                                            
											;bit [3:2]	t3sel[1:0]	ʱ3ʱԴѡ                                       
											;			t3sel[1:0]	ʱ3ʱԴ                                           
											;			00			CPUCLK                                                  
											;			01			MCK                                                     
											;			1x			ⲿʱECK(ⲿⲿҾʱЧ) 
											                                                                                
											;bit [1:0]	t2sel[1:0]	ʱ2ʱԴѡ                                       
											;			t2sel[1:0]	ʱ2ʱԴ(CKT2)                                     
											;			00			CPUCLK                                                  
											;			01			MCK                                                     
											;			1x			ⲿʱECK(ⲿⲿҾʱЧ) 

	return
	
;============================================
; ADCʼ
;============================================
ad_init:
	movlw	00000001b						;ADC CLOCK = ADC CLOCK = CPUCLK/2=4M/2=2M   תʱԼ14us 
	movwf	SRADCON0					;bit 7		QDIF	SAR_ADC׼ʹλ
											;			0ֹSAR_ADC׼
											;			1ʹSAR_ADC׼
											;			ʹSAR_ADC׼PT3.2ڽźŵĵضˣ
											;				ģڽźţԵSAR_ADCϵͳʧѹ
											
											;bit 54	SRADACKS[1:0]	ADCźŻȡʱ
											;			SRADACKS[1:0]	ADCźŻȡʱ
											;				00			16ADCʱ
											;				01			8ADCʱ
											;				10			4ADCʱ
											;				11			2ADCʱ
												
											;bit 10	SRADCKS[1:0]	ADCʱ
											;			SRADCKS[1:0]	ADCʱ
											;			00	CPUCLK
											;			01	CPUCLK/2
											;			10	CPUCLK/4
											;			11	CPUCLK/8
	
	movlw	00000000b						
 	movwf	SRADCON1						;ADCת	B[1:0]10 ڲ1.4Vο                                                     
											;sradcon1ϵ縴λֵΪ00000000                                                           
											;Bit 7		sraden 		ADCʹλ                                                               
											;			1ʹ, 0ֹ                                                                    
											                                                                                                
											;Bit 6 		srads 		ADCλ/״̬λ                                                    
											;			1ʼת                                                                 
											;			0ֹͣת                                                                   
											;			λADCתתɻԶ0                                            
											                                                                                                
											;Bit 5 		often 		תѡλ                                                      
											;			1תsroftĴ                                                        
											;			0תsradĴ                                                         
											                                                                                                
											;Bit 4 		calif 		Уλ(oftenΪ0ʱЧ)                                              
											;			1ʹУADתĽǼȥsroftʧѹֵ                                  
											;			0ֹУADתûмȥsroftʧѹֵ                                  
											                                                                                                
											;Bit 3 		enov 		ʹܱȽģʽ(califΪ1ʱЧ)                                      
											;			1ʹܣֱǼȥĽ                                               
											;			0ֹΪ000hΪfffh                                                     
											                                                                                                
											;Bit 2 		offex 		offset                                                              
											;			1ȽźŽ                                                               
											;			0ȽźŲΪźţΪοѹ                               
											                                                                                                
											;Bit[1:0]	vrefs[1:0] 	ADCοԴѡ                                                         
											;			(עͬοѹлӳ10uSADת)                                      
											;			vrefs[1:0]		ADοѹ                                                          
											;			00				VDD                                                                 
											;			01				PT3.1ⲿοԴvref1                                               
											;			10				ڲοѹοѹrefconĴУ                    
											;			11				PT3.4ⲿοԴvref2 
											
											
											

	
	movlw	00000000b												
	movwf	SRADCON2						;ADCͨ
											;bit 74	chs[3:0]	ADCͨѡλ
											;			0000		AIN0
											;			0001		AIN1
											;			0010		AIN2
											;			0011		AIN3
											;			0100		AIN4
											;			0101		AIN5
											;			0110		AIN6
											;			0111		AIN7
											;			1000		AIN8
											;			1001		AIN9룬ڲ1/8VDD
											;			1010		AIN10룬ڲοѹ
											;			1011		AIN11룬ڲӵ
											;					ڶ
												
											;bit 2		autos		ADCԶתʹλתɺ󣬸λӲ
											;			0 ֹADCԶת
											;			1 ʹADCԶת
											
	movlw	10000000B
	movwf	REFCON							;ڲοѹ
											;bit7 		ref_en		ڲοѹʹλ
											;			0:رڲοѹ
											;			1:ʹڲοѹ
											
											;bit6 		refoe		ڲοѹʹλ
											;			0 ֹڲοѹ
											;			1 ڲοѹ3.1
											
											;bit5-2 
											
											;bit[1:0]	ref_sel[1:0]	ڲοѹѡ
											;				00  			1.4V 
											;				01  			2.0V 
											;				10  			3.0V 
											;				11  			4.0V 

	movlw	10000000B
	movwf	SYSCFG0 						;߼ƽѹ
												
	movlw	11000000b
	movwf	CURCON							;

	return			
;============================================
; Ƚʼ
;============================================	
CMP_Init:
	movlw	00000000B
	movwf	CMPCON0							;bit7 		cmpen			Ƚʹλ
											;			1ʹ
											;			0ֹ
											
											;bit6-4		conźѡ
											;			cmp_nsel[2:0]	CONźŵѹV
											;			000				0.2V
											;			001				0.4V
											;			010				0.66V
											;			011				0.8V
											;			100				1.23V
											;			101				1.58V
											;			110				2.18V
											;			111				2.6V
											
											;bit3 		cmphyse			Ƚ
											;			0:ֹȽ
											;			1:ʹܱȽ
											
											;bit2 		
											
											;bit1 		cmp_oe			Ƚʹ 
											;			0:ֹȽ
											;			1:ʹܱȽ
											
											;bit0 		cmpout			Ƚֻ																																			
	
	movlw	00000000B
	movwf	CMPCON1							;bit7:
											;bit6-4		cmp_psel[2:0]	COPźѡ
											;			000				ӵ
											;			001				ӵ
											;			010				ӵ
											;			011				ӵ
											;			100				CC1_A
											;			101				CC2_A
											;			110				CC1_B
											;			111				CC2_B
											
											;bit3-0 
											
	return		
;-----------------------------------------------------------------
;UART,õUART
;-----------------------------------------------------------------
UART_Init:		
	movlw 	01010000b						;SCON1:(ϵĬֵλ:000000uu)
	movwf	SCON1 							;Bit7-6 SM0 SM1: ͨŹʽ
											;		 ʽ      
											;		00 = 0      ͬ   BaudRate = Fcpuclk/6
											;		01 = 1      첽   
											;						   TM4/16(SMOD=1)
											;						   TM4/32(SMOD=0)
											;		10 = 2		첽   Fcpuclk/16(SMOD=0)
											;						   Fcpuclk/32(SMOD=1)
											;		11 = 3		첽  
											;					   		TM4/16(SMOD=1)
											;					   		TM4/32(SMOD=0)
											 
											;Bit5   SM2: 
											;
											;Bit4   REN: տѡ
											;	1 = 
											;   0 = ֹ
											 
											;Bit3   TB8: ݵ9λ
											;
											;Bit2   RB8: ݵ9λ
											 
	                                		 
	movlw 	01101111b						;SCON2:(ϵĬֵ:000u0000)  òΪ9600
	movwf	SCON2 							;Bit7   SMOD: ѡĴ
											;		0ʱ0/2/3/432
											;		1ʱ0/2/3/416
											;bit[6:5]	URCLK[1:0]	UARTʱѡλ
											;			URCLK [1:0]		UARTʱ
											;          00   		ѡʱ0Ϊʱӣ  
											;                       SMOD=1Ϊ/16
											;                       SMOD=0Ϊ/32  
											;          01          ѡʱ2Ϊʱӣ     
											;                       SMOD=1Ϊ/16 
											;                       SMOD=0Ϊ/32   
											;			10			ѡʱ3Ϊʱӣ   
											;                       SMOD=1Ϊ/16  
											;                       SMOD=0Ϊ/32   
											;			11			ѡʱ4Ϊʱӣ  
											;                       SMOD=1Ϊ/16
											;                       SMOD=0Ϊ/32
											  
											;bit 3		UARTEN		UARTģʹ                
											;         	0ʹUARTģ                           
											;          1ʹUARTģ                             
											;          رUARTģʹλ򲻻жϱ־λ
											 
											;bit[2:0]  PINCTL[2:0] UARTͨſѡ                                                                  
											;          3b000      PT1.1PT1.2ͨIOڣPT5.1PT5.2ͨIO                                                 
											;          3b001      PT1.1UARTͨſڣPT1EN[1]PT1.2ͨIOڣPT5.1PT5.2ͨIO                                                                                                                             
											;          3b010      PT1.2UARTͨſڣPT1EN[2]PT1.1ͨIOڣPT5.1PT5.2ͨIO                                               
											;          3b011      PT1.1PT1.2ֱUARTͨſRITI PT5.1PT5.2ͨIO                        
											;          3b100      PT1.1PT1.2ͨIOڣPT5.1PT5.2ͨIO                                     
											;          3b101      PT5.1UARTͨſڣPT3EN[3]PT5.2ͨIOڣPT1.1PT1.2ͨIO     
											;          3b110      PT5.2UARTͨſڣPT3EN[4]PT5.1ͨIOڣPT1.1PT1.2ͨIO     
											;          3b111      PT5.1PT5.2ֱUARTͨſRITI PT1.1PT1.2ͨIO                        
											;          	ѡͬͨŻͬʱҪзͺͽʱΪͨſڣ
											;          	PINCTL[2:0]Ϊ3bx11PINCTL[2:0]Ϊ3bx013bx10ʱ
											;          	ʱֻһͨſʹãʱͨſڿԷʱΪRITI
											;          	IOڵķλƣ磺PINCTL[2:0]Ϊ3b001ʱ
											;          	ʱֻPT1.1UARTͨſڣPT1EN[1]Ϊ0ʱPT1ΪRIڣPT1EN[1]Ϊ1ʱPT1ΪTIڡ											
	                                		 
	clrf	SBUF 							;崮ݼĴ
return 
;============================================
; TYPE-C ʼ
;============================================	
TypeC_Init:  
 	
 	movlw	00000000B
 	movwf	CC_CTL1							;bit7 0:ʹCC2_AԴ
 											;	  1:ֹCC2_AԴ
 											
 											;bit6 0:ʹCC1_AԴ
  											;	  1:ֹCC1_AԴ	
  											
 											;bit5 0:ֹCC2_A絽VCONN
  											;	  1:ʹCC2_A絽VCONN 		
  											
  											;bit4 0:ֹCC1_A絽VCONN
  											;	  1:ʹCC1_A絽VCONN 
  											
  											;bit3 
  											
  											;bit2-0
  											;CC1_A CC2_AԴ
  											;000    5.1K 
  											;001	80uAԴ
  											;010	180uAԴ
  											;011	330uAԴ
  											;100	͵Դ
  											;101	͵Դ
  											;110	͵Դ
  											;111	100K 												
 

 	movlw	00000000B
 	movwf	CC_CTL2							;bit7 0:ʹCC2_BԴ
 											;	  1:ֹCC2_BԴ
 											
 											;bit6 0:ʹCC1_BԴ
  											;	  1:ֹCC1_BԴ	
  											
 											;bit5 0:ֹCC2_B絽VCONN
  											;	  1:ʹCC2_B絽VCONN 		
  											
  											;bit4 0:ֹCC1_B絽VCONN
  											;	  1:ʹCC1_B絽VCONN 
  											
  											;bit3 
  											
  											;bit2-0
  											;CC1_B CC2_BԴ
  											;000    5.1K 
  											;001	80uAԴ
  											;010	180uAԴ
  											;011	330uAԴ
  											;100	͵Դ
  											;101	͵Դ
  											;110	͵Դ
  											;111	100K 
  											
  	movlw	00000000B
  	movwf	CC_CTL3							;bit7 0:ֹBCCԶ
 											;	  1:ʹBCCԶ
 											
 											;bit6:4 Զ
 											;			DFP				UFP
 											;		CC1		CC2		CC1		CC2
 											;000							
 											;001	Rd				RP(3A)	
 											;010	Rd		Ra		RP(1.5A)
 											;011	Ra				Rp(Ĭ)
 											;100	Ra		Rd				Rp(3A)
 											;101			Rd				Rp(1.5A)
 											;110			Ra				RP(Ĭ)
 											;111				
  											
 											;bit3 0:ֹACCԶ
 											;	  1:ʹACCԶ
 											
 											;bit2:0 Զ
 											;			DFP				UFP
 											;		CC1		CC2		CC1		CC2
 											;000							
 											;001	Rd				RP(3A)	
 											;010	Rd		Ra		RP(1.5A)
 											;011	Ra				Rp(Ĭ)
 											;100	Ra		Rd				Rp(3A)
 											;101			Rd				Rp(1.5A)
 											;110			Ra				RP(Ĭ)
 											;111					
 											
 	movlw	00000000B	
 	movwf	CC_CTL4							;bit7 0:ֹԶɨ
 											;	  1:ʹԶɨ
 											
 											;bit6 0:ֹԶɨ
  											;	  1:ʹԶɨ
  											
 											;bit5 		
  											
  											;bit4 0:ֹλ
  											;	  1:ʹܸλ 
  											
  											;bit3 0:رձȽοѹ
  											;	  1:򿪱Ƚοѹ
  											
  											;bit2	
  											
  											;bit1-0 CCԶɨDUTYλ2CCڶЧ
  											;00		30%
  											;01		40%
  											;10		50%
  											;11		60%
 														
   	movlw	00000000B
   	movwf	PDCTL							;bit7 PDEN  USB_PDģʹλ
   											;	  0:ֹUSB_PD ģ
 											;	  1:ʹUSB_PD ģ
 											
 											;bit6 TXST	ʹλ
 											;	  0:ֹϢ
  											;	  1:ʹϢ
  											
 											;bit5 FIFOдʹλ
 											;	  0:FIFOд
 											;	  1:FIFOдPDATA31:0дFIFO
 											;	  ֻUSB-PDģBUSYλΪ0ʱܽFIFOд		
  											
  											;bit4 PD_Slow	PDͨʱBMCؿ
  											;     0:BMCźŷ>300ns
  											;	  1:BMCźŷظ
  											
  											;bit3 PWRR
  											;	  0:Sink
  											;	  1:Source
  											;ϢΪSOP'SOP"ʱ
  											;0 :ΪDFPUFPϢ
  											;1 :Ϊ¹Ϣ
  											
  											;bit2	DATR ݽɫλ
  											;0 UFP 
  											;1 DFP
  											
  											;bit1:0 CCSEL ͨCCѡ
  											;00		CC1_A
  											;01		CC2_A
  											;10		CC1_B
  											;11		CC2_B	
  											
  	movlw	00000000B
   	movwf	PDSTS							;bit7 FIFOCLR  FIFOź
   											;	  0:ֹFIFO
 											;	  1:ʹFIFO
 											
 											;bit6 
  											
 											;bit5 FIFO־ ֻ
 											;	  0:δ
 											;	  1:FIFO
 											
  											;bit4 EMPTY	FIFOձ־λֻ
  											;     0:FIFOΪ
  											;	  1:FIFOΪ
  											
  											;bit3 
  											
  											;bit2 
  											
  											;bit1  CRCERR	CRC־λ
  											;0		CRC
  											;1		ϢCRC
  											;Ӳλ
  											
  											;bit0 BUSY
  											;USB_PD æµ־λֻ	
  											;0:
  											;1:æµ
  	
  	movlw	00000000B
  	movwf	PDCMD							;bit7-4 PDϢͼĴ
  											;bit3-0 PDϢͼĴ
  	
   	movlw	00000000B
   	movwf	PDLEN							;bit7 
   											;bit6-4 RDLEN
   											;ݳȣȵλΪwork
   											;bit3 
   											;bit2-0
   											;ݳȣȵλΪwork
   											
   	movlw	00000000B
   	movwf	PDSOP							;bit7  
   											;bit6-4 յİͷֻ
   											;000	
   											;001	SOP 
   											;000	SOP
   											;001	SOP
   											;000	Hard reset
   											;001	¸λ
   											;000	
   											;001	
   											;bit3  
   											;bit2-0 Ҫ͵İͷֻ
   											;000	
   											;001	SOP 
   											;000	SOP
   											;001	SOP
   											;000	Hard reset
   											;001	¸λ
   											;000	
   											;001	
   								
   											
   	movlw	00000000B
   	movwf	PDRCV							;bit7   յϢеԴɫλֻϢΪSOPʱ
   											;		0:Sink
   											;		1:Source
   											;bit6   յϢݽɫλֻ
   											;		0UFP
											;		1DFP
   											
   											;bit5-4 Э汾ֻ
   											;	00	1.0
   											;	01	2.0
   											;	10	
   											;	11	
   											
   											;bit3 FIFOʹλ
											;0FIFO
											;1FIFOFIFOеݶ뵽PDATA[31:0]
											;ֻUSB_PDģBUSYλΪ0ʱܽFIFO
											
											;bit2-0 messageID(ֻ)
											;0---7	
	
	movlw	00000000B
	movwf	PDVSEL							;bit7 RXVSEl
											;PDոߵƽֵ
											;0PDոߵƽֵΪ0.7V
											;1PDոߵƽֵΪ0.9V
											
											;bit6-4  ѹѡ
											;000	1.35
											;001	1.3
											;010	1.25
											;011	1.2
											;100	1.15
											;101	1.1
											;110	1.05
											;111	1.0
								
	return
;============================================
; жϳʼ
;============================================
int_init:	
	clrf	LVDCON
    clrf	INTF      						; жϱ־	                                                  
	clrf	INTF2 
	clrf 	INTF3    	                
	movlf	10010000B,INTE   				; жʹܡTM0жʹܡⲿжϲʹ 
											; B7    B6     B5   B4     B3      B2   B1    B0
						         	     	; GIE   TM2IE  /    TM0IE  SRADIE  /    E1IE  E0IE

	clrf	INTE2							;Bit7 SCNBIEBCCɨжʹܱ־
											;1 = ʹBCCɨж
											;0 = ʹBCCɨж
											
											;Bit6 SCNAIEACCɨжʹܱ־
											;1 = ʹACCɨж
											;0 = ʹACCɨж
											
											;Bit 5 TM4IE12-Bitʱ/4жʹܱ־
											;1 = ʹܶʱ/4ж
											;0 = ʹܶʱ/4ж
											
											;Bit 4 TM3IE12-Bitʱ/3жʹܱ־
											;1 = ʹܶʱ/3ж
											;0 = ʹܶʱ/3ж
											
											;Bit 3 PDTOIEUSB PDͳʱжʹܱ־
											;1 = ʹUSB PDͳʱж
											;0 = ʹUSB PDͳʱж
											
											;Bit 2 PDRXIEUSB PDжʹܱ־
											;1 = ʹUSB PDж
											;0 = ʹUSB PDж
											
											;Bit 1 PDTXIEUSB PDжʹܱ־
											;1 = ʹUSB PDж
											;0 = ʹUSB PDж
											
											;Bit 0 DETIECCԶжʹܱ־
											;1 = ʹCCԶж
											;0 = ʹCCԶж 
											
	clrf	INTE3							;رնʱ3жʹ                            
	                                        ;inte3ϵ縴λֵΪ0uuuuu00              
	                                        ;Bit 7 		cmpie	Ƚжʹ              
	                                        ;			1 = ʹܱȽж                  
	                                        ;			0 = ֹȽж                  
	                                                                                        
	                                        ;Bit 1 		urtie	UARTķжʹ          
	                                        ;			1 = ʹUARTķж              
	                                        ;			0 = ֹUARTķж              
	                                                                                        
	                                        ;Bit 0 		urrie	UARTĽжʹ          
	                                        ;			1 = ʹUARTĽж              
	                                        ;			0 = ֹUARTĽж              
																																																
	bsf		CC_CTL3,CCADET					;ʹACCԶʹ
	  	    					   	 
	return	
	
	
	
	
		
	  	
	  